#include <nds.h>
#include <stdlib.h>

#define ARM7_BIOS_SIZE	0x4000

int main(int argc, char ** argv) {

	// Reset the clock if needed
	rtcReset();

	irqInit();
	SetYtrigger(80);

	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR;

	int position;
	uint16 branch = 0x5ec;
	int16 src;
	unsigned char val = 0x01;
	unsigned char *dumped_bios = (unsigned char*)malloc(ARM7_BIOS_SIZE);
	
	for(position = 0; position < ARM7_BIOS_SIZE; position++) {
		src = position - 0x12;
		asm volatile(	".thumb\n\
					mov		r3, %1\n\
					mov		r0, #5\n\
					add		r0, pc, r0\n\
					push	{r0}\n\
					push	{r2,r4,r6,r7}\n\
					mov		pc, %2\n\
					mov		%0, r3\n" : "=r"(val) : "r"(src), "r"(branch) : "r0", "r3"
					);
		dumped_bios[position] = val;
	}

	position = 0;
	while(position < ARM7_BIOS_SIZE) {	
		if(REG_IPC_FIFO_CR & IPC_FIFO_SEND_EMPTY) {
			REG_IPC_FIFO_TX = dumped_bios[position];
			position++;
		}
	}

	free(dumped_bios);
	
	// Keep the ARM7 idle
	while (1) swiWaitForVBlank();
}

