#include "nds.h"
#include <nds/arm9/console.h> //basic print funcionality
#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include "fat.h"

#define ARM7_BIOS_SIZE		0x4000
#define ARM7_BIOS_FILENAME	"BIOSNDS7.ROM"

#define ARM9_BIOS_SIZE		4096
#define ARM9_BIOS_START		((uint16*)0xFFFF0000)
#define ARM9_BIOS_FILENAME	"BIOSNDS9.ROM"

int main(void) {
	REG_IPC_FIFO_CR |= IPC_FIFO_ENABLE;
	
	videoSetMode(0);	//not using the main screen
	consoleDemoInit();

	iprintf("Trying to init FAT...");
	if(fatInitDefault()) {
		iprintf("SUCCESS!\n");
		chdir("/");
	}
	else {
		iprintf("FAILED\n");
		return 1;
	}

	FILE* arm7_file = fopen(ARM7_BIOS_FILENAME,"wb");
	
	iprintf("\n\nDumping ARM7 BIOS as "ARM7_BIOS_FILENAME"...");
	
	unsigned char* arm7_bios_dump = (unsigned char*)malloc(ARM7_BIOS_SIZE);
	int i = 0;
	
	while(i < ARM7_BIOS_SIZE) {
		if(!(REG_IPC_FIFO_CR & IPC_FIFO_RECV_EMPTY)) {
			arm7_bios_dump[i] = REG_IPC_FIFO_RX;
			i++;
		}
	}

	fwrite(arm7_bios_dump, sizeof(unsigned char), ARM7_BIOS_SIZE, arm7_file);
	fclose(arm7_file);
	iprintf("DONE\n");
	
	FILE* arm9_file = fopen(ARM9_BIOS_FILENAME,"wb");
	
	iprintf("\n\nDumping ARM9 BIOS as "ARM9_BIOS_FILENAME"...");
	fwrite(ARM9_BIOS_START, sizeof(unsigned char), ARM9_BIOS_SIZE, arm9_file);
	fclose(arm9_file);
	iprintf("DONE\n");
	
	while(1) swiWaitForVBlank();
	
	return 0;
}
